package com.hfkj.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class BsUserExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public BsUserExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andHeaderImgIsNull() {
            addCriterion("header_img is null");
            return (Criteria) this;
        }

        public Criteria andHeaderImgIsNotNull() {
            addCriterion("header_img is not null");
            return (Criteria) this;
        }

        public Criteria andHeaderImgEqualTo(String value) {
            addCriterion("header_img =", value, "headerImg");
            return (Criteria) this;
        }

        public Criteria andHeaderImgNotEqualTo(String value) {
            addCriterion("header_img <>", value, "headerImg");
            return (Criteria) this;
        }

        public Criteria andHeaderImgGreaterThan(String value) {
            addCriterion("header_img >", value, "headerImg");
            return (Criteria) this;
        }

        public Criteria andHeaderImgGreaterThanOrEqualTo(String value) {
            addCriterion("header_img >=", value, "headerImg");
            return (Criteria) this;
        }

        public Criteria andHeaderImgLessThan(String value) {
            addCriterion("header_img <", value, "headerImg");
            return (Criteria) this;
        }

        public Criteria andHeaderImgLessThanOrEqualTo(String value) {
            addCriterion("header_img <=", value, "headerImg");
            return (Criteria) this;
        }

        public Criteria andHeaderImgLike(String value) {
            addCriterion("header_img like", value, "headerImg");
            return (Criteria) this;
        }

        public Criteria andHeaderImgNotLike(String value) {
            addCriterion("header_img not like", value, "headerImg");
            return (Criteria) this;
        }

        public Criteria andHeaderImgIn(List<String> values) {
            addCriterion("header_img in", values, "headerImg");
            return (Criteria) this;
        }

        public Criteria andHeaderImgNotIn(List<String> values) {
            addCriterion("header_img not in", values, "headerImg");
            return (Criteria) this;
        }

        public Criteria andHeaderImgBetween(String value1, String value2) {
            addCriterion("header_img between", value1, value2, "headerImg");
            return (Criteria) this;
        }

        public Criteria andHeaderImgNotBetween(String value1, String value2) {
            addCriterion("header_img not between", value1, value2, "headerImg");
            return (Criteria) this;
        }

        public Criteria andUserNameIsNull() {
            addCriterion("user_name is null");
            return (Criteria) this;
        }

        public Criteria andUserNameIsNotNull() {
            addCriterion("user_name is not null");
            return (Criteria) this;
        }

        public Criteria andUserNameEqualTo(String value) {
            addCriterion("user_name =", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameNotEqualTo(String value) {
            addCriterion("user_name <>", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameGreaterThan(String value) {
            addCriterion("user_name >", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameGreaterThanOrEqualTo(String value) {
            addCriterion("user_name >=", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameLessThan(String value) {
            addCriterion("user_name <", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameLessThanOrEqualTo(String value) {
            addCriterion("user_name <=", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameLike(String value) {
            addCriterion("user_name like", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameNotLike(String value) {
            addCriterion("user_name not like", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameIn(List<String> values) {
            addCriterion("user_name in", values, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameNotIn(List<String> values) {
            addCriterion("user_name not in", values, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameBetween(String value1, String value2) {
            addCriterion("user_name between", value1, value2, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameNotBetween(String value1, String value2) {
            addCriterion("user_name not between", value1, value2, "userName");
            return (Criteria) this;
        }

        public Criteria andPhoneIsNull() {
            addCriterion("phone is null");
            return (Criteria) this;
        }

        public Criteria andPhoneIsNotNull() {
            addCriterion("phone is not null");
            return (Criteria) this;
        }

        public Criteria andPhoneEqualTo(String value) {
            addCriterion("phone =", value, "phone");
            return (Criteria) this;
        }

        public Criteria andPhoneNotEqualTo(String value) {
            addCriterion("phone <>", value, "phone");
            return (Criteria) this;
        }

        public Criteria andPhoneGreaterThan(String value) {
            addCriterion("phone >", value, "phone");
            return (Criteria) this;
        }

        public Criteria andPhoneGreaterThanOrEqualTo(String value) {
            addCriterion("phone >=", value, "phone");
            return (Criteria) this;
        }

        public Criteria andPhoneLessThan(String value) {
            addCriterion("phone <", value, "phone");
            return (Criteria) this;
        }

        public Criteria andPhoneLessThanOrEqualTo(String value) {
            addCriterion("phone <=", value, "phone");
            return (Criteria) this;
        }

        public Criteria andPhoneLike(String value) {
            addCriterion("phone like", value, "phone");
            return (Criteria) this;
        }

        public Criteria andPhoneNotLike(String value) {
            addCriterion("phone not like", value, "phone");
            return (Criteria) this;
        }

        public Criteria andPhoneIn(List<String> values) {
            addCriterion("phone in", values, "phone");
            return (Criteria) this;
        }

        public Criteria andPhoneNotIn(List<String> values) {
            addCriterion("phone not in", values, "phone");
            return (Criteria) this;
        }

        public Criteria andPhoneBetween(String value1, String value2) {
            addCriterion("phone between", value1, value2, "phone");
            return (Criteria) this;
        }

        public Criteria andPhoneNotBetween(String value1, String value2) {
            addCriterion("phone not between", value1, value2, "phone");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("`status` is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("`status` is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("`status` =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("`status` <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("`status` >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("`status` >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("`status` <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("`status` <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("`status` in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("`status` not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("`status` between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("`status` not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andWxMpOpenIdIsNull() {
            addCriterion("wx_mp_open_id is null");
            return (Criteria) this;
        }

        public Criteria andWxMpOpenIdIsNotNull() {
            addCriterion("wx_mp_open_id is not null");
            return (Criteria) this;
        }

        public Criteria andWxMpOpenIdEqualTo(String value) {
            addCriterion("wx_mp_open_id =", value, "wxMpOpenId");
            return (Criteria) this;
        }

        public Criteria andWxMpOpenIdNotEqualTo(String value) {
            addCriterion("wx_mp_open_id <>", value, "wxMpOpenId");
            return (Criteria) this;
        }

        public Criteria andWxMpOpenIdGreaterThan(String value) {
            addCriterion("wx_mp_open_id >", value, "wxMpOpenId");
            return (Criteria) this;
        }

        public Criteria andWxMpOpenIdGreaterThanOrEqualTo(String value) {
            addCriterion("wx_mp_open_id >=", value, "wxMpOpenId");
            return (Criteria) this;
        }

        public Criteria andWxMpOpenIdLessThan(String value) {
            addCriterion("wx_mp_open_id <", value, "wxMpOpenId");
            return (Criteria) this;
        }

        public Criteria andWxMpOpenIdLessThanOrEqualTo(String value) {
            addCriterion("wx_mp_open_id <=", value, "wxMpOpenId");
            return (Criteria) this;
        }

        public Criteria andWxMpOpenIdLike(String value) {
            addCriterion("wx_mp_open_id like", value, "wxMpOpenId");
            return (Criteria) this;
        }

        public Criteria andWxMpOpenIdNotLike(String value) {
            addCriterion("wx_mp_open_id not like", value, "wxMpOpenId");
            return (Criteria) this;
        }

        public Criteria andWxMpOpenIdIn(List<String> values) {
            addCriterion("wx_mp_open_id in", values, "wxMpOpenId");
            return (Criteria) this;
        }

        public Criteria andWxMpOpenIdNotIn(List<String> values) {
            addCriterion("wx_mp_open_id not in", values, "wxMpOpenId");
            return (Criteria) this;
        }

        public Criteria andWxMpOpenIdBetween(String value1, String value2) {
            addCriterion("wx_mp_open_id between", value1, value2, "wxMpOpenId");
            return (Criteria) this;
        }

        public Criteria andWxMpOpenIdNotBetween(String value1, String value2) {
            addCriterion("wx_mp_open_id not between", value1, value2, "wxMpOpenId");
            return (Criteria) this;
        }

        public Criteria andWxMaOpenIdIsNull() {
            addCriterion("wx_ma_open_id is null");
            return (Criteria) this;
        }

        public Criteria andWxMaOpenIdIsNotNull() {
            addCriterion("wx_ma_open_id is not null");
            return (Criteria) this;
        }

        public Criteria andWxMaOpenIdEqualTo(String value) {
            addCriterion("wx_ma_open_id =", value, "wxMaOpenId");
            return (Criteria) this;
        }

        public Criteria andWxMaOpenIdNotEqualTo(String value) {
            addCriterion("wx_ma_open_id <>", value, "wxMaOpenId");
            return (Criteria) this;
        }

        public Criteria andWxMaOpenIdGreaterThan(String value) {
            addCriterion("wx_ma_open_id >", value, "wxMaOpenId");
            return (Criteria) this;
        }

        public Criteria andWxMaOpenIdGreaterThanOrEqualTo(String value) {
            addCriterion("wx_ma_open_id >=", value, "wxMaOpenId");
            return (Criteria) this;
        }

        public Criteria andWxMaOpenIdLessThan(String value) {
            addCriterion("wx_ma_open_id <", value, "wxMaOpenId");
            return (Criteria) this;
        }

        public Criteria andWxMaOpenIdLessThanOrEqualTo(String value) {
            addCriterion("wx_ma_open_id <=", value, "wxMaOpenId");
            return (Criteria) this;
        }

        public Criteria andWxMaOpenIdLike(String value) {
            addCriterion("wx_ma_open_id like", value, "wxMaOpenId");
            return (Criteria) this;
        }

        public Criteria andWxMaOpenIdNotLike(String value) {
            addCriterion("wx_ma_open_id not like", value, "wxMaOpenId");
            return (Criteria) this;
        }

        public Criteria andWxMaOpenIdIn(List<String> values) {
            addCriterion("wx_ma_open_id in", values, "wxMaOpenId");
            return (Criteria) this;
        }

        public Criteria andWxMaOpenIdNotIn(List<String> values) {
            addCriterion("wx_ma_open_id not in", values, "wxMaOpenId");
            return (Criteria) this;
        }

        public Criteria andWxMaOpenIdBetween(String value1, String value2) {
            addCriterion("wx_ma_open_id between", value1, value2, "wxMaOpenId");
            return (Criteria) this;
        }

        public Criteria andWxMaOpenIdNotBetween(String value1, String value2) {
            addCriterion("wx_ma_open_id not between", value1, value2, "wxMaOpenId");
            return (Criteria) this;
        }

        public Criteria andAlipayOpenIdIsNull() {
            addCriterion("alipay_open_id is null");
            return (Criteria) this;
        }

        public Criteria andAlipayOpenIdIsNotNull() {
            addCriterion("alipay_open_id is not null");
            return (Criteria) this;
        }

        public Criteria andAlipayOpenIdEqualTo(String value) {
            addCriterion("alipay_open_id =", value, "alipayOpenId");
            return (Criteria) this;
        }

        public Criteria andAlipayOpenIdNotEqualTo(String value) {
            addCriterion("alipay_open_id <>", value, "alipayOpenId");
            return (Criteria) this;
        }

        public Criteria andAlipayOpenIdGreaterThan(String value) {
            addCriterion("alipay_open_id >", value, "alipayOpenId");
            return (Criteria) this;
        }

        public Criteria andAlipayOpenIdGreaterThanOrEqualTo(String value) {
            addCriterion("alipay_open_id >=", value, "alipayOpenId");
            return (Criteria) this;
        }

        public Criteria andAlipayOpenIdLessThan(String value) {
            addCriterion("alipay_open_id <", value, "alipayOpenId");
            return (Criteria) this;
        }

        public Criteria andAlipayOpenIdLessThanOrEqualTo(String value) {
            addCriterion("alipay_open_id <=", value, "alipayOpenId");
            return (Criteria) this;
        }

        public Criteria andAlipayOpenIdLike(String value) {
            addCriterion("alipay_open_id like", value, "alipayOpenId");
            return (Criteria) this;
        }

        public Criteria andAlipayOpenIdNotLike(String value) {
            addCriterion("alipay_open_id not like", value, "alipayOpenId");
            return (Criteria) this;
        }

        public Criteria andAlipayOpenIdIn(List<String> values) {
            addCriterion("alipay_open_id in", values, "alipayOpenId");
            return (Criteria) this;
        }

        public Criteria andAlipayOpenIdNotIn(List<String> values) {
            addCriterion("alipay_open_id not in", values, "alipayOpenId");
            return (Criteria) this;
        }

        public Criteria andAlipayOpenIdBetween(String value1, String value2) {
            addCriterion("alipay_open_id between", value1, value2, "alipayOpenId");
            return (Criteria) this;
        }

        public Criteria andAlipayOpenIdNotBetween(String value1, String value2) {
            addCriterion("alipay_open_id not between", value1, value2, "alipayOpenId");
            return (Criteria) this;
        }

        public Criteria andAgentAppidIsNull() {
            addCriterion("agent_appid is null");
            return (Criteria) this;
        }

        public Criteria andAgentAppidIsNotNull() {
            addCriterion("agent_appid is not null");
            return (Criteria) this;
        }

        public Criteria andAgentAppidEqualTo(String value) {
            addCriterion("agent_appid =", value, "agentAppid");
            return (Criteria) this;
        }

        public Criteria andAgentAppidNotEqualTo(String value) {
            addCriterion("agent_appid <>", value, "agentAppid");
            return (Criteria) this;
        }

        public Criteria andAgentAppidGreaterThan(String value) {
            addCriterion("agent_appid >", value, "agentAppid");
            return (Criteria) this;
        }

        public Criteria andAgentAppidGreaterThanOrEqualTo(String value) {
            addCriterion("agent_appid >=", value, "agentAppid");
            return (Criteria) this;
        }

        public Criteria andAgentAppidLessThan(String value) {
            addCriterion("agent_appid <", value, "agentAppid");
            return (Criteria) this;
        }

        public Criteria andAgentAppidLessThanOrEqualTo(String value) {
            addCriterion("agent_appid <=", value, "agentAppid");
            return (Criteria) this;
        }

        public Criteria andAgentAppidLike(String value) {
            addCriterion("agent_appid like", value, "agentAppid");
            return (Criteria) this;
        }

        public Criteria andAgentAppidNotLike(String value) {
            addCriterion("agent_appid not like", value, "agentAppid");
            return (Criteria) this;
        }

        public Criteria andAgentAppidIn(List<String> values) {
            addCriterion("agent_appid in", values, "agentAppid");
            return (Criteria) this;
        }

        public Criteria andAgentAppidNotIn(List<String> values) {
            addCriterion("agent_appid not in", values, "agentAppid");
            return (Criteria) this;
        }

        public Criteria andAgentAppidBetween(String value1, String value2) {
            addCriterion("agent_appid between", value1, value2, "agentAppid");
            return (Criteria) this;
        }

        public Criteria andAgentAppidNotBetween(String value1, String value2) {
            addCriterion("agent_appid not between", value1, value2, "agentAppid");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}